; Earthbound MSU1 patch by Conn 
; credits for addresses by byuu, looptable by ShadowOne333
; apply on non-header US rom

hirom

;org $E60353
;db $2f ; hardcore mute

org $C4FBF4
JSL msuTrack
NOP

org $C4FD12
JSL newTrackFlag

org $C0AC0C
JSL setFadeFlag
NOP

org $C0834e
JSL nmi

org $FD4000
msuTrack:
LDX $12  ;native code
STX $B53B
PHA
PHP ;save processor status
SEP #$20
lda $002002
CMP #$53
BEQ playmsu
PLP ;restore processor status
PLA ;get track number from stack
RTL
playmsu:
LDA #$00
STA $002006
STA $7FFFF0 ; rease new track introduced flag
TXA
STA $002004
LDA #$00
STA $002005
loop:
lda $002000
AND #$40
BNE loop
lda $002000
AND #$08
BNE playspc ; error bit set? 
LDA $FD4500,x
STA $002007
LDA #$ff
STA $002006
STA $7FFFF2 ; volume flag
LDA #$01
STA $7FFFF0 ; set new track introduced flag
LDA #$00
STA $7FFFF3 ; erase fade flag
PLP ;restore processor status
PLA ;get track number from stack
CPX #$00C0
BCC $06
LDX #$0004
STX $B53B
RTL
playspc:
LDA #$00
STA $002007
plp
pla
rtl

newTrackFlag:
SEP #$20
PHA
lda $002002
CMP #$53
BEQ $06
endflag:
PLA
JSL $C0ABBD
RTL
LDA $7FFFF0
CMP #$01
BEQ $08
LDA #$00
STA $7FFFF0 ; erase flag
BRA endflag
PLA
LDA #$00
STA $7FFFF0 ; erase flag
LDA #$04    ; mute
JSL $C0ABBD
RTL

setFadeFlag:
SEP #$20
PHA
lda $002002
CMP #$53
BEQ $05
endsetflag:
PLA
ORA $1ACB
RTL
PLA
PHA
STA $7FFFF3
BRA endsetflag

nmi:
SEP #$30
LDA $7FFFF3
BEQ endNMI
CMP #$02
BNE $03
JMP fadefast
CMP #$03
BNE $03
JMP fadeslow
cmp #$07
BNE $03
JMP fadehalf
cmp #$08
BNE $03
JMP fadefull
lda #$00
sta $7FFFF3 ;erase fade flag
endNMI:
REP #$30
STZ $99
RTL

fadeslow:
lda $7FFFF2
CMP #$00
BEQ endslow
dec
dec
cmp #$10
bcs $06
endslow:
lda #$00
sta $7FFFF3 ;erase fade flag
sta $002006
sta $7FFFF2
jmp endNMI

fadefast:
lda $7FFFF2
CMP #$00
BEQ endfast
dec
dec
dec
dec
cmp #$10
bcs $06
endfast:
lda #$00
sta $7FFFF3 ;erase fade flag
sta $002006
sta $7FFFF2
jmp endNMI

fadehalf:
lda $7FFFF2
CMP #$40    ;final level?
BEQ endhalf
dec
dec
dec
cmp #$40
bcs $08
endhalf:
lda #$00
sta $7FFFF3 ;erase fade flag
LDA #$40   ; set final level
sta $002006
sta $7FFFF2
jmp endNMI

fadefull:
lda $7FFFF2
CMP #$ff    ;final level?
BEQ endfull
inc
inc
inc
cmp #$fb
bcc $08
endfull:
lda #$00
sta $7FFFF3 ;erase fade flag
LDA #$FF
sta $002006
sta $7FFFF2
jmp endNMI

org $FD4500 ; loop table
; 01-Non-loop, 03-Loop
;   00  01  02  03  04  05  06  07  08  09  0A  0B  0C  0D  0E  0F
db $03,$01,$03,$03,$03,$03,$03,$03,$01,$01,$03,$01,$01,$01,$01,$01 ; themes 00-0f - 00
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 10-1f - 10
db $01,$01,$01,$01,$01,$01,$01,$01,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 20-2f - 20
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes 30-3f - 30
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$03,$01,$03 ; themes 40-4f - 40
db $01,$03,$03,$03,$01,$03,$03,$03,$03,$03,$01,$01,$03,$03,$01,$01 ; themes 50-5f - 50
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$01,$01 ; themes 60-6f - 60
db $03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$01,$03,$01,$01 ; themes 70-7f - 70
db $03,$03,$03,$03,$03,$03,$03,$01,$03,$01,$01,$01,$03,$03,$01,$01 ; themes 80-8f - 80
db $03,$03,$03,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01,$01,$03 ; themes 90-9f - 90
db $01,$01,$01,$01,$01,$01,$01,$01,$01,$03,$03,$03,$03,$03,$01,$01 ; themes a0-af - A0
db $01,$01,$03,$03,$01,$01,$03,$03,$03,$03,$03,$03,$03,$01,$03,$03 ; themes b0-bf - B0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes c0-cf - C0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes d0-df - D0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes e0-ef - E0
db $03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03 ; themes f0-ff - F0